unit CwinReg;
{
08/2010 : FichierINI permet de remplacer le rangement dans le registre par un fichier .INI
          teste la prsence de plusieurs fichiers : <nom_app><user><config> puis <nom_app><user> puis <nom_app>
          si introuvable, cherche dans le registre
          >permet ainsi de dfinir un fichier de base : <nom_app>.ini, tunable par l'utilisateur
14/11/07 : le message  est envoy  tous les composants, qui peuvent  ce moment accder au registre comme suit :
procedure T.WMIdesAutoReg(var Message: TWMIdesAutoReg);
var S: string;
begin
  with Message do case Action of
   0:S:=TWinReg(WinReg).GetStr(NVal); //lire
   1:TWinReg(WinReg).PutStr(NVal,S); //crire
  end;
end;
NB : comme plusieurs composants identiques peuvent cohabiter sur la mme fiche, il est judicieux d'inclure le nom du
     composant comme suit : GetStr(Name+'_'+NVal)
17/10/07 : ajout un test sur ChargeReg pour vrifier que seule la MainForm l'appelle.
           les fiches cres aprs doivent appeler ChargeRegLocal
8/9/07  tout est stock dans une seule chaine, accessible galement par les fiches temporaires, qui doivent appeler
          ChargeFenReg/RangeFenReg ; pour les fiches instancies  la cration, cet appel est automatique
19/9/06 ajout OnMajFen qui permet de demander  ttes les fiches de se mettre  jour
        appel par MettreAJourFiches(ix,pdata) ; ix est un index et pdata un pointeur
15/1/6 ajout la mise  jour auto des variables GLB selon le fichier "EnvironnementGlb.txt"
        stock sur le serveur ; utiliser verbose dans orgides non local
        (NB : un ; en 1 col dfinit une ligne commentaire - copie du fichier dans delphi7)
7/3/05 ajout Get/SetAsyncStr qui rouvre le registre pour charger/ranger la donne
6/9/04 ajout getGLBstr/putGLBstr, rang sous '\Software\Ides\' pour stocker des donnes partages entre applis sur un mme pc
4/9/04 ajout fichier INI (partage de paramtres entre plusieurs pc)
5/8/04 ajout LoadOK, ne range rien si erreur au chargement
16/7/04 introduit la gestion des configurations : sauf pour la config 0, chaque fiche d'une config
        est enregistre sous une sous-cl CONFIG_x, o x=1, 2, ...
        La config  charger/ranger est dfinie par ChargeReg(x) et stocke dans FCleConfig,
        qui vaut '' par dfaut pour la config 0, ou 'CONFIG_1', ...
        Si la config n'existe pas, WinReg tente de lire la config 0
NB : la gestion des configurations est assure par la fiche FGestionConfig

27/4/04 la touche ctrl enfonce au dmarrage empche les ancrages bas droite des composants
27/2/04 la position de fiche est recale pour tre visible  l'cran
20/9/02 ajout automatisation des associations de fichiers (Autofile1,2,3 dans le concepteur
        et procedure Associer). voir TAutoFile.
23/6/01 ajout la proprit OuvrirReduit (paramtrable dans l'exec en changeant
        la valeur lors de la lecture du registre de la fiche ppale)
12/5/01 les dimensions de fiche ne sont mises  jour que pour celles dont
        BorderStyle=bsSizeable
chaque composant WinReg range/charge sa fiche parent dans la base de registre
 et appelle OnRange/ChargeReg
toutes les informations sont ranges dans HKEY_CURRENT_USER\Software\Ides\<nom du produit>\<nom de la fiche>
<nom du produit> est la valeur de la proprit NomAppli
elle peut tre renseigne par l'appli  son lancement, avant l'appel  ChargeReg; en cas de
couplage avec le composant CDocFich, ceci doit tre fait avant l'appel  CDocFich.DebutAppli
si NomAppli est vide (=''), le nom de la fiche principale est utilis par dfaut.

pour ranger/charger la base de registre, il faut appeler
-ChargeReg dans le .DPR, aprs les CreateForm: MainForm.WinReg1.ChargeReg
-RangeReg dans la fiche principale

Chaque fiche dont on veut mmoriser la position et d'autres donnes doit contenir un
composant TWinReg.
Un des composants TWinReg de l'application est dit "principal"; c'est lui
qui DOIT contenir le nom de l'appli,
utilis comme cl de la base de registre, et qui doit tre appel en dbut et fin
de l'application; il se charge de rechercher et d'appeler tous les composants
TWinReg de l'application (y compris lui-mme) par leur procedure ChargeFenReg (resp. Range...),
cette procdure chargeant/rangeant la position de la fentre, puis appelant
l'vnement OnCharge/OnRange

Pour une fiche donne, la procedure WinReg1ChargeReg peut se prsenter comme suit:
procedure TFiche.WinReg1ChargeReg; (vnement OnCharge)
begin
  S:=WinReg1.GetStr('dernier fichier');
  li:=WinReg1.GetLong('nombre de lignes');
  ...
end;
De mme, la procedure WinReg1RangeReg peut se prsenter comme suit:
procedure TFiche.WinReg1RangeReg;  (vnement OnRange)
begin
  WinReg1.PutStr('dernier fichier',S);
  WinReg1.PutLong('nombre de lignes',li);
  ...
end;

Les functions Get/PutStr/Long lisent/rangent une valeur chaine/dword de la base, et
font rfrence au nom de la valeur, et aux donnes de la valeur;
  -lorsque les donnes de la valeur sont de type chaine, CWinReg se charge de transposer les
   guillemets simples en guillemets doubles
  -lorsque la cl est inconnue, la valeur retourne est ''(string) ou 0(longint)

Pour un composant cr sans fiche, la proprit Owner doit tre maintenue  NIL ; sinon,
  Owner est considr comme une fentre, et CWinReg tente de ranger les coordonnes  
}
interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,        //CLIPBRD,
  Forms, Dialogs, registry;

type
  TMajFicheEvent = procedure(index:integer;pdata:pointer) of object;
  TRangeRegEvent = procedure of object;
  TChargeRegEvent = procedure of object;
  TAutoFile = class(TPersistent)  //sert  enregistrer les extensions  associer dans le registre
  private
    { Dclarations private }
    Fext,             //extension  associer (sans le .) ex: cow
    Ftitre,           //nom visible dans l'explorateur ex: Fichier WinCops
    Fappli,           //chemin de l'appli, gnration auto si vide, ex: "c:\...\wincops.exe"
    Fparam: string;   //paramtre(s) de la ligne de commande, ex: "%1"
    FTestAssoc,          //FALSE:associe si extension non enregistre TRUE:teste s'il y a une association diffrente
    FNoAutoAssoc: boolean; //si association diffrente dtecte, FALSE:propose de remplacer TRUE:ne fait rien
  protected
    { Dclarations protected }
  public
    { Dclarations public }
  published
    { Dclarations published }
    property _1ext: string read Fext write Fext;
    property _2titre: string read Ftitre write Ftitre;
    property _3appli: string read Fappli write Fappli;
    property _4param: string read Fparam write Fparam;
    property TestAssoc: boolean read FTestAssoc write FTestAssoc;
    property NoAutoAssoc: boolean read FNoAutoAssoc write FNoAutoAssoc;
  end;

  TWinReg = class(TComponent)
  private
    { Dclarations private }
    FPrmIni,          //contenu d'un fichier INI
    FNomAppli,
    FCleConfig: string;  //cl de la config active, '' par dfaut, sinon fin par \
    FNumConfig: integer; //n contenu dans la cl
    FOnRangeReg: TRangeRegEvent;
    FOnChargeReg: TChargeRegEvent;
    FOuvrirReduit,
    FLoadOK: boolean;
//    Reg: TRegistry; // pour Get, Put
    FAutoFile1: TAutoFile;
    FAutoFile2: TAutoFile;
    FAutoFile3: TAutoFile;
    FOnMajFiche: TMajFicheEvent;
    Data: TStringList; //chaque ligne contient <nom_cl>TAB<nom_valeur>, Object est l'indice dans Strings
    Strings: array of string;
    mainWR: TWinReg; //le composant WR de MainForm, pour lequel Data est actif
    CleFiche: string;
    FfichierINI: boolean;//si true charge et range sur fichier .INI
    function CleAppli:string;
    function GetData(Nom:string):string;
    function PutData(Nom:string;DonneesValeur:string):string;
  protected
    { Dclarations protected }
  public
    { Dclarations public }
    constructor Create(Owner: TComponent); override;
    destructor Destroy; override;
    procedure RangeReg(numcfg:integer=-1);//si <>-1, range sous le n de config fourni
    procedure ChargeReg(numcfg:integer=0);
    procedure RangeRegLocal(numcfg:integer=-1);//si <>-1, range sous le n de config fourni
    procedure ChargeRegLocal(numcfg:integer=0);
    procedure RangeFenReg;virtual; //appel en interne ou par les fiches cres  la demande, gnre un vnement OnRangeReg
    procedure ChargeFenReg;virtual;
    function GetStr(NomValeur:string):string;
    function GetLong(NomValeur:string;defaut:integer=0):integer;
    function GetDouble(NomValeur:string;defaut:double=0):double;
    procedure PutStr(NomValeur:string;DonneesValeur:string);
    procedure PutLong(NomValeur:string;DonneesValeur:longint);
    procedure PutDouble(NomValeur:string;DonneesValeur:double);
    procedure Associer;
    property CleConfig: string read FCleConfig; //fin par \
    property NumConfig: integer read FNumConfig;
    procedure LoadINI(NF:string);
    procedure SaveINI(NF:string);
    function GetINIStr(NomValeur:string):string;
    procedure PutINIStr(NomValeur:string;DonneesValeur:string);
    procedure UpdateGLB(verbose:boolean);//met  jour le registre  partir d'un fichier
    function GetGLBStr(NomValeur:string):string;
    procedure PutGLBStr(NomValeur:string;DonneesValeur:string);
    function GetAsyncStr(NomValeur:string):string;
    procedure PutAsyncStr(NomValeur:string;DonneesValeur:string);
    procedure MettreAJourFiches(index:integer;pdata:pointer);
//
    procedure ChargerLeRegistre;
    procedure RangerLeRegistre;
    function ExisteCleAppli: boolean; //vrifie si la cl de base de rangement de l'appli existe

  published
    { Dclarations published }
    property NomAppli: string read FNomAppli write FNomAppli;
    property OuvrirReduit:boolean read FOuvrirReduit write FOuvrirReduit;
    property OnRangeReg: TRangeRegEvent read FOnRangeReg write FOnRangeReg;
    property OnChargeReg: TChargeRegEvent read FOnChargeReg write FOnChargeReg;
    property OnMajFiche: TMajFicheEvent read FOnMajFiche write FOnMajFiche;
    property AutoFile1: TAutoFile read FAutoFile1 write FAutoFile1;
    property AutoFile2: TAutoFile read FAutoFile2 write FAutoFile2;
    property AutoFile3: TAutoFile read FAutoFile3 write FAutoFile3;
    property fichierINI: boolean read FfichierINI write FfichierINI;
  end;

procedure Register;

implementation

uses {dsgnintf,} math, utils, StringUtils, dlphutil, UMessagesIDES0;

constructor TWinReg.Create(Owner: TComponent);
begin
  inherited;
  FAutoFile1:=TAutoFile.Create;
  FAutoFile2:=TAutoFile.Create;
  FAutoFile3:=TAutoFile.Create;
  CleFiche:=(Owner as TForm).Name;
end;

destructor TWinReg.Destroy;
begin
  FAutoFile1.Free;
  FAutoFile2.Free;
  FAutoFile3.Free;
  FreeAndNil(Data); //ajouter suppression des pchar
  inherited;
end;

function TWinReg.CleAppli:string;
begin
  if compacter(FNomAppli)='' then FNomAppli:=GetPathElt(Application.ExeName,k_peNom);//ShowMessage('composant WinReg : appel de ChargeReg/RangeReg avec NomAppli non assign')
  result:='\Software\Ides\'+FNomAppli;//+'\';
end;

procedure TWinReg.RangerLeRegistre;
//si FicINI, range comme fichier texte dans le dir de l'appli
var
  i: integer;
  S,cle,Sk,PF,fi: string;
  Reg: TRegistry;
begin
  cle:=CleAppli; //renseigne FNomAppli
  if FfichierINI then begin
    PF:=DirAppli+FNomAppli+'_'+UserName;
    if FCleConfig<>'' then PF:=PF+'_'+FCleConfig;
    PF:=PF+'.INI';
    fi:='';
    try
      for i:=1 to Data.Count do begin
        S:=Data[i-1]; //cleFiche+k_TAB+NomData
        fi:=fi+S+k_CRLF;
        fi:=fi+StringToDelimString( Strings[ integer( Data.Objects[i-1] ) ] )
      end;
    finally
      StringToFile(fi,PF);
    end;
  end else begin
    if FCleConfig<>'' then cle:=cle+'\'+FCleConfig;
    Reg:=TRegistry.Create;
    try
      for i:=1 to Data.Count do begin
        S:=Data[i-1];
        Sk:=LireEtOterStr0(S,k_TAB);
        if Sk='' then Sk:=cle else Sk:=cle+'\'+Sk; //c'est le cas gnral, sauf pour les valeurs situes sous la racine
        if Reg.OpenKey(Sk,true) then begin
          Reg.WriteString( S , Strings[ integer( Data.Objects[i-1] ) ] );
        end;
      end;
    finally
      Reg.Free;
    end;
  end;
end;

procedure TWinReg.RangeReg(numcfg:integer=-1);
var
  i,j: integer;
begin
  if not FLoadOK then exit;
  if numcfg>-1 then begin //enregistre sous
    if numcfg=0 then FCleConfig:='' else FCleConfig:='CONFIG_'+IntToStr(numcfg);
  end;
//met  jour Data,Strings
  for i := 0 to Application.ComponentCount-1 do begin
    if Application.Components[i] is TForm
    then with TForm(Application.Components[i]) do begin
      for j:= 0 to ComponentCount-1 do if Components[j] is TWinReg then begin
        TWinReg(Components[j]).RangeFenReg;
        break;
      end;
    end;
  end;
//range
  RangerLeRegistre;
end;

procedure TWinReg.RangeRegLocal(numcfg:integer=-1);
begin
  if not FLoadOK then exit;
  if numcfg>-1 then begin //enregistre sous
    if numcfg=0 then FCleConfig:='' else FCleConfig:='CONFIG_'+IntToStr(numcfg);
  end;
//met  jour Data,Strings
  RangeFenReg;
//range
  mainWR.RangerLeRegistre; //17/10/07
end;

procedure TWinReg.ChargerLeRegistre;
var
  Reg: TRegistry;
//  debug:string;

  procedure AddValues(K:string); //K est en gnral un nom de fiche
  var
    i: integer;
    SV: TStringList;
    RDI: TRegDataInfo;
    S,nomV: string;
  begin
    if K<>'' then K:=K+k_TAB;
    SV:=TStringList.Create;
    try
      Reg.GetValueNames(SV);
      for i:=1 to SV.Count do begin
        nomV:=SV[i-1]; S:='';
        if Reg.GetDataInfo(nomV,RDI) then begin
          case RDI.RegData of
            rdString,rdExpandString:S:=Reg.ReadString(nomV);
            rdInteger:S:=IntToStr( Reg.ReadInteger(nomV) );
            rdBinary:S:=FloatToStr( Reg.ReadFloat(nomV) );
          end;
          if S<>'' then begin
            PutData( K+nomV , S );
//            debug:=debug+'>>>>>>>>>>'+K+nomV+' ='+S+k_CRLF;
          end;
        end;
      end;
    finally
      SV.Free;
    end;
  end;
var
i,j: integer;
prefix,cle,PF,fi,S1,S2,N1,N2: string;
ok: boolean;
SK: TStringList;
begin
//  debug:='';
  if Assigned(Data) then Data.Clear else Data:=TStringList.Create;
  if FfichierINI then begin  //fichier INI
    CleAppli; //renseigne FNomAppli
    N1:='_'+UserName;
    if FCleConfig<>'' then N2:='_'+FCleConfig else N2:='';

    PF:=DirAppli+FNomAppli+N1+N2+'.INI';
    fi:=StringFromFile(PF);
    if fi='' then begin
      PF:=DirAppli+FNomAppli+N1+'.INI';
      fi:=StringFromFile(PF);
      if fi='' then begin
        PF:=DirAppli+FNomAppli+'.INI';
        fi:=StringFromFile(PF);
      end;
    end;
    if fi<>'' then begin //sinon, on ira chercher dans le registre
      //translater en Data
      repeat
        S1:=LgetS(fi);
        if S1='' then exit;
        S2:=LireDelimString(fi);
        PutData(S1,S2);
      until false;
      exit;
    end;
  end;
  //registre
  Reg:=TRegistry.Create;
  SK:=TStringList.Create;
  try
    cle:=CleAppli+'\'+FCleConfig;
    ok:= Reg.OpenKey(cle,false);
    if not ok then begin
      cle:=CleAppli;
      ok:= Reg.OpenKey(cle,false);
    end;
// charge config par dfaut si config demande n'existe pas
    if ok then begin
      AddValues(''); //valeurs de la racine
      Reg.GetKeyNames(SK);
      for i:=1 to SK.Count do begin
        if Reg.OpenKey(cle+'\'+SK[i-1],false) then AddValues(SK[i-1]);
      end;
    end;
    FLoadOK:=true;
  finally
//    clipboard.AsText:=debug;
    Reg.Free;
    SK.Free;
  end;
end;

procedure TWinReg.ChargeReg(numcfg:integer=0);
//appel une seule fois dans MainForm
var
  i,j: integer;
  fiches: array of TForm;
begin
  if pointer(self.Owner)<>pointer(Application.MainForm) then ShowMessage('erreur CWinReg : seule MainForm peut appeler ChargeReg');
  mainWR:=self;
  FLoadOK:=false;
  if numcfg=0 then FCleConfig:='' else FCleConfig:='CONFIG_'+IntToStr(numcfg);
  FNumConfig:=numcfg;
  ChargerLeRegistre;
  try
    //recenser les fiches
    fiches:=nil; j:=0;
    for i := 0 to Application.ComponentCount-1 do begin
      if Application.Components[i] is TForm then begin
        SetLength(fiches,j+1);
        fiches[j]:=TForm(Application.Components[i]);
        inc(j);
      end;
    end;
    //chercher le WinReg
    for i:=0 to High(fiches) do with fiches[i] do begin
//charger la fiche du registre
      for j:= 0 to ComponentCount-1 do if Components[j] is TWinReg then begin
        TWinReg(Components[j]).mainWR:=self;
        try
          //showmessage('trace '+GetOwnerForm(Components[j]).Name);
          TWinReg(Components[j]).ChargeFenReg;
        except
          on E:exception do ShowMessage(E.Message+' dans '+GetOwnerForm(Components[j]).Name+',TWinReg.ChargeFenReg');
        end;
        break;
      end;
    end;
    FLoadOK:=true;
  finally
//    if FOuvrirReduit then Application.MainForm.WindowState:=wsMinimized;
    if not FLoadOK then ShowMessage('erreur au chargement du registre');
    if FOuvrirReduit then Application.Minimize;//6/10/01
    Associer;//procde aux associations de fichiers, si elles sont dfinies
  end;
end;

procedure TWinReg.ChargeRegLocal(numcfg:integer=0);
var
  i,j: integer;
begin
//  mainWR:=self;
  FLoadOK:=false;
  if numcfg=0 then FCleConfig:='' else FCleConfig:='CONFIG_'+IntToStr(numcfg);
  FNumConfig:=numcfg;
  try
//charger la fiche du registre
    ChargeFenReg;
    FLoadOK:=true;
  finally
    if not FLoadOK then ShowMessage('erreur au chargement du registre');
  end;
end;

function GetMainWR:TWinReg;
var
  i: integer;
begin
  with Application.MainForm do for i:=0 to ComponentCount-1 do if Components[i] is TWinReg then begin
    result:=TWinReg( Components[i] );
    exit;
  end;
  result:=nil;
end;

procedure TWinReg.RangeFenReg;
var
  S: string;
  WP: TWindowPlacement;
  F: TForm;
  i: integer;
begin            //exit;
  try
    if Owner=NIL then exit; //pas dpos sur une fiche
    F:=(Owner as TForm);
    if mainWR=nil then mainWR:=GetMainWR;
    if mainWR=nil then exit;
    CleFiche:=F.Name; //une redite...
    S:='';
    WP.Length:=sizeof(WP);
    GetWindowPlacement( F.Handle,@WP );
    with WP do begin
      if showCmd=SW_SHOWMAXIMIZED  then S:='A';//mAxim...
      if showCmd=SW_SHOWMINIMIZED  then S:='I';//mInim...
    end;
    with WP.rcNormalPosition do
      PutStr('WinLTWH' , S+Format('%d %d %d %d',[Left,Top,Right-Left,Bottom-Top]) );
    if Trim(AutoFile1._1ext+AutoFile2._1ext+AutoFile3._1ext)<>''
      then PutStr('NoAutoAssociation',FT[AutoFile1.NoAutoAssoc]+FT[AutoFile2.NoAutoAssoc]+FT[AutoFile3.NoAutoAssoc]);
    if Assigned(FOnRangeReg) then FOnRangeReg;
//rangements auto faits par les composants
    for i:= 0 to F.ComponentCount-1 do if F.Components[i] is TWinControl then
    SendMessage(TWinControl(F.Components[i]).Handle,WM_IDESAUTOREG,Longint(Self),1);// 1 pour ranger dans le registre
  except end;
end;

procedure TWinReg.ChargeFenReg;
var
  S: string;
  C: char;
  F: TForm;
  i,W,H: integer;
  alLT: boolean;
  Ct: TControl;
begin            //exit;
  try
    if Owner=NIL then exit; //PAS dpos sur une fiche
    Application.ProcessMessages; //pour viter les anomalies d'ancrage
    if mainWR=nil then mainWR:=GetMainWR;
    if mainWR=nil then exit;
    F:=(Owner as TForm);
    CleFiche:=F.Name; //une redite...
    if GetKeyState(VK_LCONTROL)<0 then begin
 //touche ctrlG enfonce, supprimer les alignements bas droite et passer en alNone
      H:=0; W:=0;
      for i:=1 to F.ControlCount do begin
        Ct:=F.Controls[i-1];
        Ct.Anchors:=[akTop,akLeft];
        Ct.Top:=max(Ct.Top,0);
        Ct.Left:=max(Ct.Left,0);
        H:=max(H,Ct.Top+Ct.Height);
        W:=max(W,Ct.Left+Ct.Width);
      end;
      F.ClientHeight:=max(F.ClientHeight,H);
      F.ClientWidth:=max(F.ClientWidth,W);
    end else begin
      S:=GetStr('WinLTWH');
      if S<>'' then begin
        C:=UpCase(S[1]);
        if (C='A') or (C='I') then system.delete(S,1,1);
        F.WindowState:=wsNormal;
{        with F.Constraints do begin
          if MinHeight=0 then MinHeight:=F.Height;
          if MinWidth=0 then MinWidth:=F.Width;
        end; }
        DecodeWin(S,F);
        if (C='A') then F.WindowState:=wsMaximized;
        if (C='I') then begin
          TForm(Owner).WindowState:=wsMinimized;
        end;
      end;
    end;
    RecalerPositionForm(F);
    Application.ProcessMessages; //pour viter les anomalies d'ancrage
    S:=GetStr('NoAutoAssociation')+'FFF';
    AutoFile1.NoAutoAssoc:=S[1]='T';
    AutoFile2.NoAutoAssoc:=S[2]='T';
    AutoFile3.NoAutoAssoc:=S[3]='T';
    if Assigned(FOnChargeReg) then FOnChargeReg;
//rangements auto faits par les composants
    for i:= 0 to F.ComponentCount-1 do if F.Components[i] is TWinControl then
      SendMessage(TWinControl(F.Components[i]).Handle,WM_IDESAUTOREG,Longint(Self),0);// 0 pour charger du registre
  except
    on Exception do;
  end;
end;

procedure TWinReg.MettreAJourFiches(index:integer;pdata:pointer);
var
  i,j: integer;
begin
  for i := 0 to Application.ComponentCount-1 do begin
    if Application.Components[i] is TForm
    then with TForm(Application.Components[i]) do begin
      for j:= 0 to ComponentCount-1 do if Components[j] is TWinReg then begin
        with TWinReg(Components[j]) do if Assigned(FOnMajFiche) then try
          FOnMajFiche(index,pdata);
        except
          On E:Exception do ShowMessage(Owner.Name+' : '+E.Message);
        end;
        break;
      end;
    end;
  end;
end;

function TWinReg.GetData(Nom:string):string;
var
  i: integer;
begin
  i:=Data.IndexOf(Nom);
  if i=-1 then result:='' else begin
    i:=integer( Data.Objects[i] );
    result:=Strings[i];
  end;
end;

function TWinReg.GetStr(NomValeur:string):string;
begin
  result:=mainWR.GetData(CleFiche+k_TAB+NomValeur);
end;

function TWinReg.GetLong(NomValeur:string;defaut:integer=0):integer;
begin
  Result:=StrToIntDef(mainWR.GetData(CleFiche+k_TAB+NomValeur),defaut);//Reg.ReadInteger(NomValeur);
end;

function TWinReg.GetDouble(NomValeur:string;defaut:double=0):double;
begin
  Result:=StrToFloatDef(mainWR.GetData(CleFiche+k_TAB+NomValeur),defaut);//Reg.ReadInteger(NomValeur);
end;

function TWinReg.PutData(Nom:string;DonneesValeur:string):string;
var
  i,j: integer;
begin
  i:=Data.IndexOf(Nom);
  if i=-1 then begin
    j:=length(Strings);
    SetLength(Strings,j+1);
    Data.AddObject( Nom , TObject(j) );
  end else j:=integer( Data.Objects[i] );
  Strings[j]:=DonneesValeur;
end;

procedure TWinReg.PutStr(NomValeur:string;DonneesValeur:string);
begin
  mainWR.PutData(CleFiche+k_TAB+NomValeur,DonneesValeur);
end;

procedure TWinReg.PutLong(NomValeur:string;DonneesValeur:longint);
begin
  mainWR.PutData(CleFiche+k_TAB+NomValeur,IntToStr(DonneesValeur));
end;

procedure TWinReg.PutDouble(NomValeur:string;DonneesValeur:double);
begin
  mainWR.PutData(CleFiche+k_TAB+NomValeur,FloatToStr(DonneesValeur));
end;

procedure TWinReg.Associer;
  procedure assoc_(AF:TAutoFile);
  var
    Reg: TRegistry;
    Ext,
    NomAuto,
    Titre,
    Appli: string;

    procedure CreerCles;
    var
      ok: boolean;
      Sk: string;
    begin
      ok:=false;
      try
        Sk:='.'+Ext;
        Reg.CreateKey(Sk);
        if Reg.OpenKey(Sk,false) then begin
          Reg.WriteString('',NomAuto);
          Reg.CloseKey;
          Sk:=NomAuto+'\shell\open\command';
          Reg.CreateKey(Sk);
          if Reg.OpenKey(NomAuto,false) then begin
            Reg.WriteString('',Titre);
            Reg.CloseKey;
          end;
          if Reg.OpenKey(Sk,false) then begin
            Reg.WriteString('',Appli);
            Reg.CloseKey;
          end;
        end;
        ok:=true;
      except
        on Exception do;
      end;
      if not ok then ShowMessage('erreur registre pour .'+Ext);
    end;

  var
    S,Sna,Snf: string;
    idem: boolean;
  begin
    Ext:=Trim(AF.Fext);
    if Ext='' then exit;
    NomAuto:=Ext+'_auto_file';
    Titre:=Trim(AF.Ftitre);
    if Titre='' then Titre:='fichier '+Ext;
    Appli:=Trim(AF.Fappli);
    if (Appli='') or (Appli='""') then Appli:='"'+ExpandUNCFileName(Application.ExeName)+'"';
    Appli:=Appli+' '+Trim(AF.Fparam);
    Reg:=TRegistry.Create;
    try
      Reg.RootKey:=HKEY_CLASSES_ROOT;
      if Reg.KeyExists('.'+Ext) then begin //mise  jour
        if AF.FTestAssoc then try  //TRUE:teste s'il y a une association diffrente
          if Reg.OpenKey('.'+Ext,false) then begin
            Sna:=Reg.ReadString('');
            Reg.CloseKey;
            idem:= UpperCase(Sna)=UpperCase(NomAuto) ;
          end;
          if idem and Reg.OpenKey(Sna,false) then begin
            Snf:=Reg.ReadString('');
            Reg.CloseKey;
            idem:= UpperCase(Snf)=UpperCase(Titre) ;
          end;
          if idem and Reg.OpenKey(Sna+'\shell\open\command',false) then begin
            S:=Reg.ReadString('');
            Reg.CloseKey;
            idem:= UpperCase(S)=UpperCase(Appli) ;
          end;
          if idem then exit;//inchang
//association diffrente dtecte, FALSE:propose de remplacer TRUE:ne fait rien
          if AF.FNoAutoAssoc then exit;
          if MessageDlg('les fichiers de type '+Ext{Snf}+' ne sont pas associs'#13+
                        ' l''application '+ExtractFileName(Application.ExeName)+' ;'#13+
                        'Voulez-vous qu''ils le deviennent?',mtConfirmation,[mbYes,mbNo],0)
          =mrYes then begin
            Reg.DeleteKey('.'+Ext);
            Reg.DeleteKey(Sna);
            CreerCles;
          end else begin
            if MessageDlg('ce choix est il dfinitif?',mtConfirmation,[mbYes,mbNo],0)
            =mrYes then AF.FNoAutoAssoc:=true;//ne posera plus la question
          end;
        except
          on Exception do;
        end;
      end else CreerCles;
    finally
      Reg.Free;
    end;
  end;

begin
  assoc_(FAutoFile1);
  assoc_(FAutoFile2);
  assoc_(FAutoFile3);
end;

procedure TWinReg.LoadINI(NF:string);
begin
  FPrmINI:=StringFromFile(NF);
end;

procedure TWinReg.SaveINI(NF:string);
begin
  StringToFile(FPrmINI,NF);
end;

function TWinReg.GetINIStr(NomValeur:string):string;
var
  SL: TStringList;
begin
  SL:= TStringList.Create;
  try
    SL.Text:=FPrmINI;
    result:=SL.Values[NomValeur];
  finally
    SL.Free;
  end;
end;

procedure TWinReg.PutINIStr(NomValeur:string;DonneesValeur:string);
var
  SL: TStringList;
begin
  SL:= TStringList.Create;
  try
    SL.Text:=FPrmINI;
    SL.Values[NomValeur]:=DonneesValeur;
    FPrmINI:=SL.Text;
  finally
    SL.Free;
  end;
end;

procedure TWinReg.UpdateGLB(verbose:boolean);
//tente de mettre  jour les variables GLB  partir du fichier EnvironnementGlb.txt
//si verbose, demande o est le fichier si introuvable
var
  pf,S,S1,Sn: string;
  OD: TOpenDialog;
  i: integer;
begin
  pf:=GetGLBStr('path_fichier_environnement_glb');
  if ((pf='') or not FileExists(pf)) then begin
    if verbose then begin
      OD:=TOpenDialog.Create(nil);
      try
        OD.Title:='recherche fichier d''environnement';
        OD.Filter:='fichier d''environnement (EnvironnementGlb.txt)|(EnvironnementGlb.txt)';
        OD.FilterIndex:=0;
        if OD.Execute then begin
          pf:=OD.FileName;
          PutGLBStr('path_fichier_environnement_glb',pf);
        end;
      finally
        OD.Free;
      end;
    end else pf:='';
  end;
  if pf='' then exit;
  S:=GetGLBStr('date_fichier_environnement_glb');
  S1:=IntToStr(FileAge(pf));
  if S<>S1 then begin //mettre  jour
    PutGLBStr('date_fichier_environnement_glb',S1);
    S:=StringFromFile(pf);
    while S<>'' do begin
      S1:=TrimLeft(LigLireEtOter(S));
      if not ((S1='') or (Copy(S1,1,1)=';')) then begin //sinon comm
        Sn:=Trim(LireEtOterStr0(S1,'='));
        S1:=Trim(S1);
        if (Sn<>'') then PutGLBStr(Sn,S1);
      end;
    end;
  end;
end;

function TWinReg.GetGLBStr(NomValeur:string):string;
var
  Reg: TRegistry;
  ok: boolean;
begin
  result:='';
  Reg:=TRegistry.Create;
  try
    ok:= Reg.OpenKey('\Software\Ides',false);
    if ok then result:=Reg.ReadString(NomValeur);
  finally
    Reg.Free;
  end;
end;

procedure TWinReg.PutGLBStr(NomValeur:string;DonneesValeur:string);
var
  Reg: TRegistry;
  ok: boolean;
begin
  Reg:=TRegistry.Create;
  try
    ok:= Reg.OpenKey('\Software\Ides',false);
    if ok then Reg.WriteString(NomValeur,DonneesValeur);
  finally
    Reg.Free;
  end;
end;

function TWinReg.GetAsyncStr(NomValeur:string):string;
var
  Reg: TRegistry;
  ok: boolean;
begin
  result:='';
  Reg:=TRegistry.Create;
  try
    ok:= Reg.OpenKey('\Software\Ides\'+FNomAppli+'\',false);
    if ok then result:=Reg.ReadString(NomValeur);
  finally
    Reg.Free;
  end;
end;

procedure TWinReg.PutAsyncStr(NomValeur:string;DonneesValeur:string);
var
  Reg: TRegistry;
  ok: boolean;
begin
  Reg:=TRegistry.Create;
  try
    ok:= Reg.OpenKey('\Software\Ides\'+FNomAppli+'\',false);
    if ok then Reg.WriteString(NomValeur,DonneesValeur);
  finally
    Reg.Free;
  end;
end;

function TWinReg.ExisteCleAppli: boolean; //vrifie si la cl de base de rangement de l'appli existe
var
S: string;
Reg: TRegistry;
begin
  S:=CleAppli;
  Reg:=TRegistry.Create;
  try
    result:= Reg.OpenKey('\Software\Ides\'+FNomAppli,false);
  finally
    Reg.Free;
  end;
end;

procedure Register;
begin
  RegisterComponents('Perso', [TWinReg]);
end;

end.


















{
Registry Entries for Extending the Shell

An application that creates and maintains files, such as a spreadsheet, word proces-sor, or graphics application, typically adds two keys to the system registry: a file association key and an application identifier key. The file association key maps a filename extension to an application identifier. For example, a word processing application might register the following key under HKEY_CLASSES_ROOT.

HKEY_CLASSES_ROOT  
    .doc=AWordProcessor 
 

The value name (.doc) specifies the filename extension, and the value (AWordProcessor) denotes the key name that contains the information about the application handling the filename extension.
The application identifier key is the second registry entry made by an application handling files.

HKEY_CLASSES_ROOT
    AWordProcessor=A Word Processor 
 

The value (A Word Processor) is a string describing the application that recognizes files having the given filename extension. (In this case, it is the .DOC filename extension.) 
Extending the shell requires that you add other entries below the file association and application identifier keys. The system checks these entries to determine the commands to add to various shell menus, when to load an extension DLL, where to find the DLL, and so on.
There are several registry keys that allow you to extend the shell without having to write any code at all. These keys let you set the default icon for a class of files or add commands to the File menu and its New submenu in Windows Explorer.

Modifying the Context Menu for a File Class

When the user clicks a file object using mouse button 2, the system displays a context menu for the object. The context menu contains a set of menu items that allow the user to perform various operations on the file object, such as opening or printing it. A context menu contains two types of items: dynamic items and static items. Dynamic items are added to a context menu by a context menu handler.

Static menu items are listed in the system registry and are automatically added to a context menu by the system. Because static items are listed in the system registry based on their class, the context menus for all file objects belonging to a particular class receive the same set of static items.
You specify static menu items for a file class by adding a shell key below the application identifier key of the file class and then adding verb and command value entries below the shell key. Following is the registry format for static items.

HKEY_CLASSES_ROOT
    <applicationID> = <"description">
        shell
            <verb> = <"menu-item text">
                command = <"command string">


Each verb value entry specifies a menu-item text string for the system to add to the context menu. The command value entry specifies the action that the system takes when the user chooses the menu item. Typically, the command string value specifies the path and filename of an application and includes command-line options that direct the application to perform an action on the corresponding file object. For example, the following registry keys add an Open command and a Print command to the context menu for all files with the .WRI filename extension.

HKEY_CLASSES_ROOT
  wrifile = Write Document
      shell
        open
          command = C:\Progra~1\Access~1\WORDPAD.EXE %1 
            print 
          command = C:\Progra~1\Access~1\WORDPAD.EXE /p "%1" 
            printto 
          command = 
            C:\Progra~1\Access~1\WORDPAD.EXE /pt "%1" "%2" "%3" "%4" 
 

In the preceding commands, the %1 parameter is the filename, %2 is the printer name, %3 is the driver name, and %4 is the port name. In Windows 95, you can ignore the %3 and %4 parameters (the printer name is unique in Windows 95).
The system defines a set of verbs called canonical verbs that introduce an element of language-independence to context menus. When you include a canonical verb in the registry, the system automatically generates a localized menu item string for the verb before adding it to the context menu. The canonical verbs include the open, print, explore, find, openas, and properties verbs. The printto verb is also canonical, but it is a special case because it is never actually displayed. Instead, it allows the user to print a file by dragging it to a printer object. Canonical verbs are also used with context menu handlers. 

If the open canonical verb is included in the registry entries for a file class, the system adds an Open menu item to the corresponding context menu and makes it the default item. If the open verb is not included, the menu item corresponding to the verb listed in the registry is the default item. A context menu handler can change the default item. For more information about context menu handlers, see Context Menu Handlers.

