unit DlphUtil;

interface
uses Forms, Controls, StdCtrls, classes, SysUtils, Graphics, WinTypes, WinProcs,
     Registry, Grids, Windows, Dialogs, ComCtrls, ExtCtrls;

type
  TSetFont = procedure(Cv:TCanvas;numfnt:integer); //proc de rappel pour Line2Canvas

const
  k_FileModeNetRead      = OF_SHARE_EXCLUSIVE+OF_READ;
(*  k_FileModeNetReadWrite = OF_SHARE_EXCLUSIVE+OF_READWRITE;*)
  k_001 : char = #1;
  k_para = #13;
  k_CRLF = #13#10;
  CRLF = k_CRLF;
  
  k_ShortStr = true; //pour L/E fichier stream
  k_LongStr = false;

procedure SGCopyCells(SGd,SGs:TStringGrid);
procedure SGSuppRow(SG:TStringGrid;Row:longint);//Row=0..
procedure SGAjusterCols(SG:TStringGrid;min:longint);
procedure SGLrgColsAuto(SG:TStringGrid);
function MaxWidth(S:TStrings; Cv:TCanvas):longint;
function TrimQuotedStr(S:string):string;
function CommaStr(S:string):string;
function Str2CommaStr(S:string):string;
function CommaStr2Str(S:string):string;
function QuotedStr2SepStr(S:string; sep:char):string;
function ExtractString0(SL: TStringList):string;
//stream
function StreamRead(ST:TFileStream;var S: string;ss: boolean):string;//Result=S
procedure StreamWrite(ST:TFileStream;const S: string;ss: boolean);
function StreamReadLn(FS: TFileStream):string;
procedure StreamWriteLn(FS: TFileStream;buf:string);
function StreamReadStr(FS: TFileStream):string; //lit le reste du fichier dans une string
procedure StreamWriteStr(FS: TFileStream;buf:string);

procedure ReadStr(var F:file;var S:OpenString);
procedure  WriteStr(var F:file;S:OpenString);
procedure Readdouble(var F:file;var R:double);
procedure  Writedouble(var F:file;R:double);
function Memo2Buf(Memo:TMemo):PChar;
procedure ViderListe(L:TStrings);
procedure MajHisto(H:TStringList;S:string);
function MouseInForm(F:TForm):boolean;
procedure PutWin(SL:TStringList;nom:string;F:TForm);
function EncodeWin(F:TForm):string;
procedure DecodeWin(S:string;F:TForm);
procedure SetClientSize(F:TForm;W,H:integer);
procedure RecalerPositionForm(F:TForm);
procedure GetWin(SL:TStringList;nom:string;F:TForm);
procedure EncodeFont(var S:string;F:TFont);
function FontToStr(F:TFont):string;
procedure PutFont(SL:TStringList;nom:string;F:TFont);
procedure DecodeFont(S:string;F:TFont);
procedure GetFont(SL:TStringList;nom:string;F:TFont);
procedure Bip;
procedure AfficheErreurES(msg:string;code:longint);
function ExpandDir(dir:string):string;//renvoie un string sans \final, sauf si c:
function AddBackSlash(dir:string):string;
//function normDir(path:string):string;
function RunAppli(ExecDir,Cde,Params:string;linkapp:boolean=true):HINST;
function RunAppli2(ExecDir,Cde,Params:string;linkapp:boolean=true):HINST;
function RunAppAndWait(ExecDir,Cde,Params:string):cardinal;
function ReadRegStr(R:TRegistry;const nom,defaut:string):string;
function ReadRegInt(R:TRegistry;const nom:string;const defaut:longint):longint;
procedure SlToReg(R:TRegistry;const Cle:string;SL:TStringList);
procedure SlToText(var F:TextFile;const Cle:string;SL:TStringList);
procedure RegToSL(R:TRegistry;const Cle:string;SL:TStringList);
procedure TextToSL(var F:TextFile;const Cle:string;SL:TStringList);
procedure decLength(var S:string;n:integer=1);
function NomServeur(S:string):string;// 1/5/99
function NomFichierUnique(S,Sep,initial:string):string;// 13/5/99 renvoie S au format UNC suivi d'un nombre
procedure BackerFichier(S:string);//13/5/99 cre un back du fichier de path S avec un ~ en dbut d'extension
procedure Wait(ms:integer);
function DirWindows:string;
function CurrentDir:string;
procedure ShellExOpen(hw:HWND;PF:string);
//procedure SauverString(PF,S:string);   VOIR STRINGTOFILE (UTILS)
procedure OuvrirFic(WinHndl:HWND;dirdef,fic:string);
procedure OuvrirBlocNotes(pf:string);
procedure ClearStringList(SL:TStrings);//supprime aussi les objets
function MessageDlgCt(const Msg: string; DlgType: TMsgDlgType; Buttons: TMsgDlgButtons;
                       HelpCtx: Longint;Ct:TControl): Integer;//la boite s'aligne sur le contrle
function GetFileProperty(PF:string;codeprop:integer):string;
function NumRevision:string;
function ListView_GetColsWidths(LV:TListView;sep:char=' '): string;
procedure ListView_SetColsWidths(LV:TListView;const Value:string; minW: integer;sep:char=' ');
function HC_GetColsWidths(HC:THeaderControl;sep:char=' '): string;
procedure HC_SetColsWidths(HC:THeaderControl;const Value:string; minW: integer;sep:char=' ');
procedure Line2Canvas(Cv:TCanvas;Raff:TRect;Text:string;SetFont:TSetFont);
procedure Text2Canvas(Cv:TCanvas;Raff:TRect;Text:string;GCD:char);
procedure Text2RichEdit(RE:TRichEdit;data:string;add:boolean=false);
procedure ShowOnTop(F:TForm);
procedure ReinitTimer(T:TTimer);
function PointInRect(P:TPoint;R:TRect):boolean; //coord cran
function PointInControl(P:TPoint;C:TWinControl):boolean;
function MouseInControl(C:TWinControl):boolean;
procedure RecenserAideContextuelle;
procedure InsererAideContextuelle(PF: string);

function SamePoint(P1,P2:TPoint):boolean;

implementation

uses StrUtils, Utils, StringUtils, ShellAPI, Messages, Math, ShlObj, ComObj, Clipbrd;

{ routines-type d'initialisation de fentre

DANS FENETRE PPALE:

procedure TF.RangeFichierINI;
var
  T: TextFile;
  Rep: string;
begin
  Rep:=RepFichiers+'x.INI';
  try
    AssignFile(T,Rep);
    Rewrite(T);
    if not Fy.RangeINI(T) then Abort;
    CloseFile(T);
  except
    on E:EInOutError do
        AfficheErreurES('criture de '+Rep,E.ErrorCode);
  end;
end;

procedure TF.ChargeFichierINI;
var
  SL: TStringList;
  PF: string;
begin
  PF:=RepFichiers+'x.INI';
  if not FileExists(PF) then exit;

  SL:=TStringList.Create;
  try
    try
      SL.LoadFromFile(PF);
      if not Fy.ChargeINI(SL) then Abort;
    except
      on E:EInOutError do
        AfficheErreurES('lecture de '+PF,E.ErrorCode);
    end;
  finally
    SL.Free;
  end;
end;

POUR CHAQUE FENETRE:

procedure Tx.RangeINI(var SL:TStringList);
begin
  SL.Add('[x]');
  PutWin(SL,Name,Self);
  PutFont(SL,Name,y.Font);
end;

procedure Tx.ChargeINI(var SL:TStringList);
begin
  GetWin(SL,Name,Self);
  GetFont(SL,Name,y.Font);
end;
}

procedure SGCopyCells(SGd,SGs:TStringGrid);
//ne copie pas Cols et Rows fixes
var
  i,j,fcs,frs,fcd,frd,m,n: longint;
begin
  fcs:=SGs.FixedCols;
  fcd:=SGd.FixedCols;
  m:=SGs.ColCount-fcs-1;
  frs:=SGs.FixedRows;
  frd:=SGd.FixedRows;
  n:=SGs.RowCount-frs-1;
  SGd.ColCount:=SGs.ColCount;
  SGd.RowCount:=SGs.RowCount;
  for i:=0 to n do
    for j:=0 to m do SGd.Cells[fcd+j,frd+i]:=SGs.Cells[fcs+j,frs+i];
end;

procedure SGSuppRow(SG:TStringGrid;Row:longint);//Row=0..
var
  i,j: longint;
begin
  if SG.RowCount=0 then exit;
  SG.Rows[SG.Row].Clear;
  for i:=Row to SG.RowCount-2 do
    for j:=1 to SG.ColCount do SG.Cells[j-1,i]:=SG.Cells[j-1,i+1];
  SG.RowCount:=SG.RowCount-1;
end;

procedure SGAjusterCols(SG:TStringGrid;min:longint);
var
  i,j,n: longint;
begin
  n:=SG.ColCount;
  j:=SG.ClientWidth-1;
  for i:=1 to n-1 do j:=j-SG.ColWidths[i-1]-SG.GridLineWidth;
  if j>min then SG.ColWidths[n-1]:=j;
end;

procedure SGLrgColsAuto(SG:TStringGrid);
var
  i,j,l,lc: longint;
begin
  for i:=1 to SG.ColCount do begin
    l:=0;
    for j:=1 to SG.RowCount do begin
      lc:=SG.Canvas.TextWidth(SG.Cells[i-1,j-1]);
      if lc>l then l:=lc;
    end;
    SG.ColWidths[i-1]:=l+2;
  end;
end;

function MaxWidth(S:TStrings; Cv:TCanvas):longint;
var
  i,l: longint;
begin
  Result:=0;
  for i:=1 to S.Count do begin
    l:=Cv.TextWidth(S[i-1]);
    if l>Result then Result:=l;
  end;
end;

function TrimQuotedStr(S:string):string;
var
  SL: TStringList;
  i: longint;
begin
  SL:=TStringList.Create;
  try
    SL.CommaText:=S;
    for i:=0 to SL.Count-1 do SL[i]:=Trim(SL[i]);
    S:=SL.CommaText;
    Result:=S;
  finally
    SL.Free;
  end;
end;

function CommaStr(S:string):string;
begin
  if S='' then Result:='" "' else Result:=AnsiQuotedStr(S,'"');
end;

function Str2CommaStr(S:string):string;
var
  SL: TStringList;
begin
  SL:=TStringList.Create;
  try
    SL.Add(S);
    result:=SL.CommaText;
  finally
    SL.Free;
  end;
end;

function CommaStr2Str(S:string):string;
var
  SL: TStringList;
begin
  SL:=TStringList.Create;
  try
    SL.CommaText:=S;
    if SL.Count=0 then result:='' else result:=SL[0];
  finally
    SL.Free;
  end;
end;

function QuotedStr2SepStr(S:string; sep:char):string;
var
  SL: TStringList;
  i: longint;
begin
  SL:=TStringList.Create;
  try
    SL.CommaText:=S;
    Result:='';
    for i:=0 to SL.Count-1 do Result:=Result+SL[i]+sep;
    DecLength(Result,1);
  finally
    SL.Free;
  end;
end;

function SepStr2QuotedStr(S:string; sep:char):string;
var
  S1: string;
  i,n: longint;
begin
  Result:='';
  n:=NbrSep(S,#1);
  for i:=0 to n do begin
    S1:=ExtraireStr(i,S,sep);
    if i>0 then Result:=Result+',';
    S1:=ANSIQuotedStr(S1,'"');
    if S1<>'""' then Result:=Result+S1;
  end;
end;

function ExtractString0(SL: TStringList):string;
begin
  if SL.Count=0 then Result:=''
  else begin
    Result:=SL[0];
    SL.Delete(0);
  end;
end;

function StreamRead(ST:TFileStream;var S: string; ss: boolean):string;
//si ss, ShortString, 1 octet pour la longueur, sinon 4
const
  lgs: array[boolean] of byte = (4,1);
var
  l: integer;
begin
  l:=0;
  ST.Read(l,lgs[ss]);   
  SetLength(S,l);
  ST.Read(pchar(S)^,l);  // showmessage(inttostr(l)+' : '+S);
  Result:=S;
end;

procedure StreamWrite(ST:TFileStream;const S: string; ss: boolean);
//si ss, ShortString, 1 octet pour la longueur, sinon 4
const
  lgs: array[boolean] of byte = (4,1);
var
  l: integer;
begin
  l:=Length(S);
  ST.Write(l,lgs[ss]);
  ST.Write(pchar(S)^,l);
end;

procedure ReadStr(var F:file;var S:ShortString);
var
  b: byte;
begin
  BlockRead(F,b,1);
  BlockRead(F,S[1],b);
  S[0]:=chr(b);
end;
{**********}
procedure Readdouble(var F:file;var R:double);
begin
  BlockRead(F,R,sizeof(R));
end;
{**********}
procedure  WriteStr(var F:file;S:ShortString);
begin
  BlockWrite(F,S[0],length(S)+1);
end;
{**********}
procedure  Writedouble(var F:file;R:double);
begin
  BlockWrite(F,R,sizeof(R));
end;
{**********}
function Memo2Buf(Memo:TMemo):PChar;
{ne vide pas Memo
 dans l'autre sens Memo.SetTextBuf(PChar)
}
var
  Size: integer;
begin
  Size := Memo.GetTextLen;
  Inc(Size);                      {ajoute de la place pour le caractre nul}
  GetMem(Result, Size);           {cre la variable dynamique Buffer}
  Memo.GetTextBuf(Result,Size);  {place Edit1.Text dans Buffer}
end;
{**********}
procedure ViderListe(L:TStrings);
var
  i: longint;
begin
  Screen.cursor:=crHourGlass;
  try
    while L.Count>0 do begin
      i:=L.Count-1;
      L.Objects[i].Free;
      L.Delete(i);
    end;
  finally
    Screen.cursor:=crDefault;
  end;
end;
{**********}
procedure MajHisto(H:TStringList;S:string);
var
  i: longint;
begin
  S:=UpperCase(S);
  for i:=0 to H.Count-1 do if UpperCase(H.Strings[i])=S then begin
    if i>0 then H.Move(i,0);
    exit;
  end;
  H.Insert(0,S);
end;
{**********}
function EncodeWin(F:TForm):string;
begin
  Result:=Format('%d %d %d %d',[F.Left,F.Top,F.Width,F.Height]);
end;
{**********}
procedure PutWin(SL:TStringList;nom:string;F:TForm);
begin
  SL.Add('Win'+nom+EncodeWin(F));
end;
{**********}
procedure SetClientSize(F:TForm;W,H:integer);
begin
  F.Width:=W +F.Width-F.ClientWidth;
  F.Height:=H +F.Height-F.ClientHeight;
end;
{**********}
function MouseInForm(F:TForm):boolean;
var p:TPoint;
begin
  p:=Mouse.CursorPos;
  result:= ((p.X>=F.Left) and (p.X<=F.Left+F.Width) and (p.Y>=F.Top) and (p.Y<=F.Top+F.Height));
//  result:= ((msX>=0) and (msX<=F.ClientWidth) and (msY>=0) and (msY<=F.ClientHeight));
end;
{**********}
procedure DecodeWin(S:string;F:TForm);
var
  L,T,W,H: longint;
begin
  if not lire_entier(S,L) then exit;
  L:=Max(L,0);
  if not lire_entier(S,T) then exit;
  T:=Max(T,0);
  if not lire_entier(S,W) then exit;
  if not lire_entier(S,H) then exit;
//  if L+W > Screen.Width then L:=Max(0,Screen.Width-W);
//  if T+H > Screen.Height then T:=Max(0,Screen.Height-H);
  MoveWindow(F.Handle,L,T,W,H,true);
//au 28/12/02 pour pb de resize au chargement de reg
{  if not lire_entier(S,li) then exit;
  F.Left:=li;
  if not lire_entier(S,li) then exit;
  F.Top:=li;
  if not lire_entier(S,li) then exit;
  if F.BorderStyle=bsSizeable then F.Width:=li;
  if not lire_entier(S,li) then exit;
  if F.BorderStyle=bsSizeable then F.Height:=li;}
end;
{**********}
procedure RecalerPositionForm(F:TForm);
const
  k_mrg = 50;
var
  SW,SH: integer;
begin
  SH:=Screen.Height-k_mrg;
  SW:=Screen.Width-k_mrg;
  if F.Left>SW then F.Left:=SW;
  if F.Left+F.Width<k_mrg then F.Left:=k_mrg-F.Width;
  if F.Top>SH then F.Top:=SH;
  if F.Top+F.Height<k_mrg then F.Top:=k_mrg-F.Height;
end;
{**********}
procedure GetWin(SL:TStringList;nom:string;F:TForm);
var
  S: string;
begin
  S:=SL.Values['Win'+nom];
  DecodeWin(S,F);
end;
{**********}
procedure EncodeFont(var S:string;F:TFont);
begin
  S:='"'+F.Name+'" '+IntToStr(F.Size)+' '+IntToStr(F.Color)+' ';
  if fsBold in F.Style then S:=S+'B';
  if fsItalic in F.Style then S:=S+'I';
  if fsUnderline in F.Style then S:=S+'U';
end;
function FontToStr(F:TFont):string;
begin
  EncodeFont(result,F);
end;
{**********}
procedure PutFont(SL:TStringList;nom:string;F:TFont);
var
  S: string;
begin
  EncodeFont(S,F);
  SL.Add('Font'+nom+'='+S);
end;
{**********}
procedure DecodeFont(S:string;F:TFont);
//"nom" taille couleur BIU
var
  i: longint;
  li: longint;
begin
  if S='' then exit;
  delete(S,1,1); //1er "
  i:=pos('"',S);
  F.Name:=copy(S,1,i-1);
  delete(S,1,i);
  if not lire_entier(S,li) then exit;
  F.Size:=li;
  if not lire_entier(S,li) then exit;
  F.Color:=li;
  F.Style:=[];
  S:=UpperCase(TrimLeft(S));
  if pos('B',S)>0 then F.Style:=F.Style+[fsBold];
  if pos('I',S)>0 then F.Style:=F.Style+[fsItalic];
  if pos('U',S)>0 then F.Style:=F.Style+[fsUnderline];
end;
{**********}
procedure GetFont(SL:TStringList;nom:string;F:TFont);
var
  S: string;
begin
  S:=SL.Values['Font'+nom];
  DecodeFont(S,F);
end;
{**********}
procedure Bip;
begin
  MessageBeep(MB_ICONHAND);
end;
{**********}
procedure AfficheErreurES(msg:string;code:longint);
var
  S: string;
begin
  case code of
    2:S:='fichier introuvable';
    3:S:='chemin introuvable';
    4:S:='trop de fichiers ouverts';
    5:S:='accs au fichier refus';
    6:S:='identificateur de fichier incorrect';
    12:S:='mode d''accs fichier incorrect';
    15:S:='unit de disque incorrecte';
    16:S:='le rpertoire ne peut tre supprim';
    17:S:='ne peut renommer de disque  disque';

    100:S:='erreur lecture disque';
    101:S:='erreur criture disque';
    102:S:='variable non fichier';
    103:S:='fichier ferm';
    104:S:='fichier non ouvert en lecture';
    105:S:='fichier non ouvert en criture';
    106:S:='format numrique incorrect';

    else S:='code inconnu:'+IntToStr(code)
  end;
  MessageDlg(msg+':'#13#10+S,mtError,[mbOK],0);
end;
{**********}
{function ExpandDir(dir:string):string;
begin
  dir:=ExpandUNCFileName(dir+'*');
  declength(dir,1);
  if dir[Length(dir)]<>'\' then dir:=dir+'\';
  Result:=dir;
end;
{**********}
function ExpandDir(dir:string):string;//renvoie un string sans \final, sauf si c:
begin
  if Trim(dir)='' then dir:=CurrentDir;
  dir:=ExcludeTrailingPathDelimiter(dir);//+'\';
  dir:=ExpandUNCFileName(dir);
  if dir[length(dir)]=':' then dir:=dir+'\';
  result:=dir;
end;
{**********}
function AddBackSlash(dir:string):string;
//27/12/06 : supprime tous les backslash multiples (sauf en dbut o \\xx est accept)
var  i: integer;
begin
  result:=Trim(dir);
  if result='' then exit;
  result:=result+'\';
  repeat
    i:=PosEx('\\',result,2);
    if i=0 then exit;
    delete(result,i,1);
  until false;
//  if result[length(result)]<>'\' then result:=result+'\';
end;
{**********}
(*function normDir(path:string):string;  //ote le \ final
var
  SR: TSearchRec;
begin
  path:=ExpandUNCFileName(Trim(path));
  while path[length(path)]='\' do declength(path);
//  path:=UpperCase(compacter(path)); 29/04/00 incompatible avec noms longs
  if (path='') or (path[length(path)]=':') then begin
    path:=ExpandFileName(path+'.');
    SetLength(path,Length(path)-1);
    Result:=path;
    exit;
  end;
  if (path[length(path)]<>'\') then path:=path+'\';
  if FindFirst(path+'*.*',faAnyFile,SR)<0
  then MessageDlg('rpertoire inconnu:'#13#10+path,mtWarning,[mbOK],0);
  Result:=path;
end;  *)
{**********}
function RunAppli2(ExecDir,Cde,Params:string;linkapp:boolean=true):HINST;
//9/7/07 : Params ne sera plus entour de guillemets automatiquement, mais sera pris comme une image de la ligne de commande
var
  cde_, prm_, dir_: PAnsiChar;
  lnk: HWND;
begin
  ExecDir:=ExcludeTrailingBackslash(ExecDir);
  if ExecDir='' then begin
    ExecDir:=ExtractFilePath(ExpandUNCFileName(Cde));
    ExecDir:=ExcludeTrailingBackslash(ExecDir);
  end;
  cde_:=NIL;
  prm_:=NIL;
  dir_:=NIL;
  Params:=Trim(Params);
//////  if (Params<>'') and (Params[1]<>'"') then Params:='"'+Params+'"';
  try
    cde_:=StrAlloc(length(Cde)+16);
    StrPCopy(cde_,Cde);
    if Params<>'' then begin
      prm_:=StrAlloc(length(Params)+16);
      StrPCopy(prm_,Params);
    end;
    dir_:=StrAlloc(length(ExecDir)+16);
    StrPCopy(dir_,ExecDir);
    if linkapp then lnk:=Application.{MainForm.}handle  else lnk:=0;
    result:=ShellExecute(lnk , 'open', cde_, prm_, dir_, SW_SHOWNORMAL);
  finally
    StrDispose(cde_);
    StrDispose(prm_);
    StrDispose(dir_);
  end;
  if result<33 then begin
    ShowMessage(Cde+' :'#13+TxtShellErr(result));
    result:=0;
  end;
end;
function RunAppli(ExecDir,Cde,Params:string;linkapp:boolean=true):HINST;
begin
  Params:=Trim(Params);
  if (Params<>'') and (Params[1]<>'"') then Params:='"'+Params+'"';
  result:=RunAppli2(ExecDir,Cde,Params,linkapp);
end;
function RunAppAndWait(ExecDir,Cde,Params:string):cardinal;
//renvoie l'exit code
var
  shexinf: TShellExecuteInfoA;
  cde_, prm_, dir_: PChar;
begin
  Params:=Trim(Params);
  if (Params<>'') and (Params[1]<>'"') then Params:='"'+Params+'"';
  ExecDir:=ExcludeTrailingBackslash(ExecDir);
  if ExecDir='' then begin
    ExecDir:=ExtractFilePath(ExpandUNCFileName(Cde));
    ExecDir:=ExcludeTrailingBackslash(ExecDir);
  end;
  cde_:=NIL;
  prm_:=NIL;
  dir_:=NIL;
  Params:=Trim(Params);
//////  if (Params<>'') and (Params[1]<>'"') then Params:='"'+Params+'"';
  try
    cde_:=StrAlloc(length(Cde)+16);
    StrPCopy(cde_,Cde);
    if Params<>'' then begin
      prm_:=StrAlloc(length(Params)+16);
      StrPCopy(prm_,Params);
    end;
    dir_:=StrAlloc(length(ExecDir)+16);
    StrPCopy(dir_,ExecDir);

    fillchar(shexinf,sizeof(shexinf),0);
    shexinf.cbSize:=sizeof(shexinf);
    shexinf.lpDirectory:=dir_;
    shexinf.lpVerb:='open';
    shexinf.lpFile:=cde_;
    shexinf.lpParameters:=prm_;
    shexinf.nShow:=SW_SHOWNORMAL;
    shexinf.fMask:=SEE_MASK_DOENVSUBST or SEE_MASK_NOCLOSEPROCESS or SEE_MASK_IDLIST;
    if ShellExecuteEx(@shexinf) then begin
      while WaitForSingleObject(shexinf.hProcess,200)=WAIT_TIMEOUT do Application.ProcessMessages;
      GetExitCodeProcess(shexinf.hProcess,result);
      CloseHandle(shexinf.hProcess);
    end else result:=0;//erreur
  finally
    StrDispose(cde_);
    StrDispose(prm_);
    StrDispose(dir_);
  end;
end;
{**********}
function AppliActive(H:HINST):boolean;
var
  i: cardinal;
begin
  result:= GetExitCodeProcess(H,i) and (i=STILL_ACTIVE);
end;
{**********}
function ReadRegStr(R:TRegistry;const nom,defaut:string):string;
begin
  try
    Result:=R.ReadString(nom);
  except
    on ERegistryException do Result:=defaut;
  end;
end;
{**********}
function ReadRegInt(R:TRegistry;const nom:string;const defaut:longint):longint;
begin
  try
    Result:=R.ReadInteger(nom);
  except
    on ERegistryException do Result:=defaut;
  end;
end;
{**********}
procedure SlToReg(R:TRegistry;const Cle:string;SL:TStringList);
var
  i: longint;
  S: string;
begin
  if R.OpenKey(Cle, true) then begin
    for i:=1 to SL.Count do begin
      S:=SL.Names[i-1];
      R.WriteString(S,SL.Values[S]);
    end;
    R.CloseKey;
  end;
end;
{**********}
procedure SlToText(var F:TextFile;const Cle:string;SL:TStringList);
var
  i: longint;
begin
  writeln(F,'[',Cle,']');
  for i:=1 to SL.Count do begin
    writeln(F,SL[i-1]);
  end;
  writeln(F,'[fin ',Cle,']');
end;
{**********}
procedure RegToSL(R:TRegistry;const Cle:string;SL:TStringList);
var
  i: longint;
begin
  if R.OpenKey(Cle, false) then begin
    R.GetValueNames(SL);
    for i:=1 to SL.Count do begin
      SL[i-1]:=SL[i-1]+'='+R.ReadString(SL[i-1]);
    end;
    R.CloseKey;
  end;
end;
{**********}
procedure TextToSL(var F:TextFile;const Cle:string;SL:TStringList);
var
  S: string;
begin
  readln(F,S);
  if S<> '['+Cle+']' then exit;
  repeat
    readln(F,S);
    if S='[fin '+Cle+']' then break;
    SL.Add(S);
  until false;
end;
{**********}
procedure decLength(var S:string;n:integer=1);
var
  i: longint;
begin
  if n<=0 then exit;
  i:=Length(S)-n;
  if i>=0 then SetLength(S,i);  //=ajout le 221005
end;

function NomServeur(S:string):string;
var
  i,j: longint;
begin
  S:=ExtractFileDrive(ExpandUNCFileName(S));
  j:=length(S);
  for i:=3 to j do if S[i]='\' then break;
  system.Delete(S,i,j);
  result:=S;
end;

function NomFichierUnique(S,Sep,initial:string):string;
//S est un path ou un nom (dans ce cas, tendu au fichier courant),  incluant l'extension
// 13/5/99 renvoie S suivi d'un nombre (indice) prcdent l'extension
// 24/5/00 corrig, S doit tre fourni sans indice ; Sep contient un ventuel sparateur (espace, tiret, ...
// 15/5/04 si sep='(' , referme la parenthse
// initial contient '1' (ou autre) pour crer Nouveau1 au lieu de Nouveau (par ex!)
// 16/8/04 si sep='(', dmarre le n de doublon  2
var
  i: longint;
  S1,Sx: string;
begin
  S:=Trim(ExpandUNCFileName(S));
//spare ext
  Sx:=ExtractFileExt(S);
  SetLength(S,length(S)-length(Sx));
  if sep='(' then i:=1 else i:=0;
  S1:=initial;//pour commencer sans indice
  while FileExists(S+S1+Sx) do begin
    inc(i);
    S1:=Sep+IntToStr(i);
    if Sep='(' then S1:=S1+')';
  end;
  result:=S+S1+Sx;
end;

procedure BackerFichier(S:string);
var
  E,Sn: string;
begin
  E:=ExtractFileExt(S);
  if system.copy(E,1,1)<>'~' then E:='~'+E;
  Sn:=S;
  ChangeFileExt(Sn,'.'+E);
  DeleteFile(PChar(Sn));
  RenameFile(S,Sn);
end;

procedure Wait(ms:integer);
var
  fin: TDateTime;
begin
  fin:=Time+ms/(24*3600*1000);
  while Time<fin do begin
    Application.ProcessMessages;
    Windows.Sleep(10);
  end;
end;

function DirWindows:string;
var
  Pc: array[0..MAX_PATH+10] of char;
begin
  GetWindowsDirectory(Pc,MAX_PATH+10);
  Result:=string(Pc);
end;

function CurrentDir:string;
var
  Pc: array[0..MAX_PATH+10] of char;
begin
  GetCurrentDirectory(MAX_PATH+10,Pc);
  Result:=string(Pc);
end;

procedure ShellExOpen(hw:HWND;PF:string);
begin
  ShellExecute(hw,'open',PChar(PF),nil,nil,SW_SHOWNORMAL);
end;

(*procedure SauverString(PF,S:string);
var
  F: TextFile;
begin
  AssignFile(F, PF);
  Rewrite(F);
  Writeln(F, S);
  CloseFile(F);
end;    *)

procedure OuvrirFic(WinHndl:HWND;dirdef,fic:string);
var
  i: integer;
  fic_,
  dir_: array[0..1023] of char;
begin
  StrPCopy(@dir_,ExcludeTrailingBackslash(dirdef));
  StrPCopy(@fic_,fic);
  i:=ShellExecute(WinHndl, 'open', @fic_, NIL, @dir_, SW_SHOWNORMAL);
  if i<33 then ShowMessage(fic+' :'#13+TxtShellErr(i));
end;

procedure OuvrirBlocNotes(pf:string);
var
i: integer;
begin
  pf:='"'+pf+'"'#0;
  i:=ShellExecute( 0 , 'open', 'NOTEPAD.EXE' , @pf[1] , nil , SW_SHOWNORMAL);
  if i<33 then ShowMessage(pf+' :'#13+TxtShellErr(i));
end;

procedure ClearStringList(SL:TStrings);
//supprime aussi les objets
var
  i: integer;
  O: TObject;
begin
//d'abord les objets (la mthode Destroy de l'objet DOIT tre OVERRIDE)
  for i:=1 to SL.Count do begin
    O:=TObject(SL.Objects[i-1]);
    if Assigned(O) then begin
      O.Free;
      SL.Objects[i-1]:=NIL;
    end;
  end;
//puis les lignes
  SL.Clear;
end;

function MessageDlgCt(const Msg: string; DlgType: TMsgDlgType; Buttons: TMsgDlgButtons; HelpCtx: Longint;Ct:TControl): Integer;
//la boite s'aligne sur le contrle
var
  P: TPoint;
begin
  P:=Ct.Parent.ClientToScreen(Point(Ct.Left,Ct.Top));
  Result := MessageDlgPosHelp(Msg, DlgType, Buttons, HelpCtx, P.X, P.Y, '');
end;

function StreamReadLn(FS: TFileStream):string; //lit une ligne (fin par #13
var
  buf: string[255];
//  ofs: int64;
  lus,i: integer;
begin
  result:='';
//  ofs:=FS.Position;
  repeat
    lus:=FS.Read(buf[1],255);
    if lus=0 then break; //EOF
    buf[0]:=chr(lus);
    i:=Pos(#13,buf);
    if i=0 then result:=result+buf
    else begin
      result:=result+Copy(buf,1,i-1);
      i:=length(buf)-(i+1);
      FS.Seek( -i,soFromCurrent);
      break;
    end;
  until false;
end;

function StreamReadStr(FS: TFileStream):string; //lit le reste du fichier dans une string
var
  n: int64;
begin
  n:=FS.Size-FS.Position;
  SetLength(result,n);
  FS.Read(result[1],n);
end;

procedure StreamWriteLn(FS: TFileStream;buf:string);
begin
  buf:=buf+#13#10;
  FS.Write(buf[1],length(buf));
end;

procedure StreamWriteStr(FS: TFileStream;buf:string);
begin
  FS.Write(buf[1],length(buf));
end;

function GetFileProperty(PF:string;codeprop:integer):string;
{  20/5/07
PID Property name Type      !! ne marche au mieux que pour les LPSTR
2 Title VT_LPSTR
3 Subject VT_LPSTR
4 Author VT_LPSTR
5 Keywords VT_LPSTR
6 Comments VT_LPSTR
7 Template VT_LPSTR
8 Last Saved By VT_LPSTR
9 Revision Number VT_LPSTR
10 Total Editing Time VT_FILETIME
11 Last Printed VT_FILETIME
12 Create Time/Date VT_FILETIME
13 Last Saved Time/Date VT_FILETIME
14 Number of Pages VT_I4
15 Number of Words VT_I4
16 Number of Characters VT_I4
17 Thumbnail VT_CF
18 Name of Creating Application VT_LPSTR
19 Security VT_I4
}
var
  DF,NF: string;
  lpi,att,l: cardinal;
  ISF: IShellFolder;
  ISF2: IShellFolder2;
  ppidl: PitemIdList;
  SCI: SHCOLUMNID;
  ov: OleVariant;
  pwc: PWideChar;
begin
  result:='';
  pwc:=nil;
  ISF2:=nil;
  OleCheck(SHGetDesktopFolder(ISF));
  try
    att:=0;
    PF:=ExpandUNCFileName(PF);
    DF:=GetPathElt(PF,k_peDrvDir);
    NF:=GetPathElt(PF,k_peNomExt);
    l:=length(DF)*2+1;
    GetMem(pwc,l);
    StringToWideChar(DF,pwc,l);
    OleCheck(ISF.ParseDisplayName(0,nil,pwc,lpi,ppidl,att));//pointe sur le rpertoire
    OleCheck(ISF.BindToObject(ppidl,nil, IID_IShellFolder2, ISF2));
    ppidl:=nil;
    SCI.fmtid:=StringToGUID('{F29F85E0-4FF9-1068-AB91-08002B27B3D9}');
    SCI.pid:=codeprop;
    FreeMem(pwc);
    l:=length(NF)*2+1;
    GetMem(pwc,l);
    StringToWideChar(NF,pwc,l);
    OleCheck(ISF2.ParseDisplayName(0,nil,pwc,lpi,ppidl,att));//pidl du fichier
    OleCheck(ISF2.GetDetailsEx(ppidl,SCI,@ov));
    result:=ov;
  finally
//    if Assigned(ISF2) then ISF2._Release;
    ISF._Release;
    FreeMem(pwc);
    ppidl:=nil;
  end;

(*  result:='';
  l:=GetFileVersionInfoSize(PAnsiChar(PF),l1);
  if l=0 then begin
    ShowMessage( FormatSysErrCode(GetLastError) );
    exit;
  end;
  GetMem(Buf,l+1);
  try
    if GetFileVersionInfo(PAnsiChar(PF),l1,l,@Buf1) then begin
      VerQueryValue(Buf,PChar('\StringFileInfo\040904E4\'+prop),Pinfo,lp);
      result:=PChar(Pinfo);
    end;
  finally
    FreeMem(Buf);
  end;  *)
end;

function NumRevision:string;
const
  Pcde: PChar = '\';
var
  l,l1: DWORD;
  Buf:pointer;
  S:string;
  lp: UINT;
  Pinfo: ^VS_FIXEDFILEINFO;
begin
  result:='informations de rvision non accessibles';
  S:=Application.ExeName;
  l:=GetFileVersionInfoSize(PAnsiChar(S),l1);
  if l=0 then exit;
  GetMem(Buf,l+1);
  if GetFileVersionInfo(PAnsiChar(S),l1,l,Buf) then begin
    VerQueryValue(Buf,Pcde,pointer(Pinfo),lp);
    if Pinfo<>NIL
    then result:='Rvision '+
              IntToStr( HiWord( Pinfo^.dwProductVersionMS ) )+'.'+
              IntToStr( LoWord( Pinfo^.dwProductVersionMS ) )+'.'+
              IntToStr( HiWord( Pinfo^.dwProductVersionLS ) )+'.'+
              IntToStr( LoWord( Pinfo^.dwProductVersionLS ) );
  end;
  FreeMem(Buf);
end;

function ListView_GetColsWidths(LV:TListView;sep:char=' '): string;
var
  i: integer;
begin
  result:='';
  with LV.Columns do for i:=1 to LV.Columns.Count do
    result:=result+sep+IntToStr(LV.Columns[i-1].Width);
  delete(result,1,1);
end;

procedure ListView_SetColsWidths(LV:TListView;const Value:string; minW: integer;sep:char=' ');
var
  i: integer;
begin
  if LV.ViewStyle=vsReport then begin
    for i:=1 to LV.Columns.Count do with LV.Columns[i-1] do
        Width:=StrToIntDef(ExtraireStr(i-1,Value,sep),minW);
    LV.Repaint;
  end;
end;

function HC_GetColsWidths(HC:THeaderControl;sep:char=' '): string;
var
  i: integer;
begin
  result:='';
  for i:=1 to HC.Sections.Count do
    result:=result+sep+IntToStr(HC.Sections[i-1].Width);
  delete(result,1,1);
end;

procedure HC_SetColsWidths(HC:THeaderControl;const Value:string; minW: integer;sep:char=' ');
var
  i: integer;
begin
  for i:=1 to HC.Sections.Count do with HC.Sections[i-1] do
      Width:=StrToIntDef(ExtraireStr(i-1,Value,sep),minW);
  HC.Repaint;
end;

procedure Line2Canvas(Cv:TCanvas;Raff:TRect;Text:string;SetFont:TSetFont);
{dmarre avec la fonte 0, changt par $i dans le texte, i=0..7}
var
  S1: string;
  i,deb,lg: integer;
  C: char;
begin
try
  SetFont(Cv,0);
  deb:=1;
  repeat
    i:=Pos('$',Text);
    if i=0 then lg:=Length(Text) else lg:=i-deb;
    if lg>0 then begin
      S1:=Copy(Text,deb,lg);
      Cv.TextRect(Raff,Raff.Left,Raff.Top,S1);
      Raff.Left:=Raff.Left+Cv.TextWidth(S1);
    end;
    if i>0 then begin
      S1:=Copy(Text,i+1,1);
      Text[i]:=' ';//ote $
      deb:=i+1;
      if length(S1)>0 then begin
        C:=S1[1];
        if (C>='0') and (C<='7') then begin
          SetFont( Cv , ord(C)-ord('0') );
          inc(deb);
        end;
      end;
    end;
  until i=0;
except end;
end;

procedure Text2Canvas(Cv:TCanvas;Raff:TRect;Text:string;GCD:char);
{Text contient des cars de contrle idem Undc (dans PRJSTD)
 (codage "jp", dnomm AS pour ampersand)
envoi de texte grec : &&\texte& affiche <texte> avec la police greekc
 (texte ne peut pas commencer avec &,#)
dfinition de police  : &&#[taille_police][nom_police]& (fin par &),
                        &&#& : police prcdente
dfinition d'indice   : &&-texte& <texte> est affich en indice
dfinition d'exposant : &&+texte& <texte> est affich en exposant
dfinitions de styles : &&@xxx& (fin par &),
                        o x=G,g,I,i,S,s G=gras I=italique S=soulign
                          la majuscule active le style, la minuscule dsactive
                        ou x=Cy : dfinition de couleur, y=N (noir), Vert, Bleu, Rouge, Jaune
                        &&@GSCR& est admis
GCD dfinit le centrage
}
var
  w,svsz,Yecr,svy,h: integer;
  savpol: string;
  Recr: TRect;
  procedure wr_txt(calw:boolean);//si calw, ne calcule que la longueur
  var
    data,S,Sprm,Sf: string;
    procedure PutText(txt:string);
    var  wl: integer;
    begin
      if txt='' then exit;
      wl:=Cv.TextWidth(txt);
      if not calw then begin
        Recr.Left:=w;
        Cv.TextRect(Recr,w,Yecr,txt);
      end;
      inc(w,wl);
    end;
    procedure SetPol(S:string);
    var
      sz: integer;
    begin
      sz:=0;
      while (S<>'') and (S[1] in ['0'..'9']) do begin
        sz:=sz*10+StrToInt(Copy(S,1,1));
        Delete(S,1,1);
      end;
      S:=Trim(S);
      if sz<>0 then Cv.Font.Size:=sz;
      if S<>'' then Cv.Font.Name:=S;
    end;
  begin
    data:=Text;
    Yecr:=Raff.Top+1;
    repeat
      PutText( StrLireEtOterStr0(data,'&&') );
      S:=LireEtOterDebutStr(data,1)+' ';
      Sprm:=StrLireEtOterStr0(data,'&');
      case S[1] of
      '@':begin //style
            while Sprm<>'' do begin
              case Sprm[1] of
              'C':begin
                case (Sprm+' ')[2] of
                'N':Cv.Font.Color:=clBlack;
                'B':Cv.Font.Color:=clBlue;
                'V':Cv.Font.Color:=clGreen;
                'R':Cv.Font.Color:=clRed;
                'J':Cv.Font.Color:=clYellow;
                end;
                Delete(Sprm,1,1);
              end;
              'G':Cv.Font.Style:=Cv.Font.Style+[fsBold];
              'g':Cv.Font.Style:=Cv.Font.Style-[fsBold];
              'I':Cv.Font.Style:=Cv.Font.Style+[fsItalic];
              'i':Cv.Font.Style:=Cv.Font.Style-[fsItalic];
              'S':Cv.Font.Style:=Cv.Font.Style+[fsUnderline];
              's':Cv.Font.Style:=Cv.Font.Style-[fsUnderline];
              end;
              Delete(Sprm,1,1);
            end;
          end;
      '\':begin //txt grec
          Sf:=Cv.Font.Name;
          Cv.Font.Name:='GreekC';
          PutText(Sprm);
          Cv.Font.Name:=Sf;
        end;
      '+',//exposant
      '-':begin//indice
          svsz:=Cv.Font.Size;
          h:=svsz*Cv.Font.PixelsPerInch div 144;//mi-ht 
          Cv.Font.Size:=svsz-2; //ote 2 points
          svy:=Yecr;
          if S[1]='+' then Yecr:=Raff.Top else Yecr:=Yecr+h;
          PutText(Sprm);
          Cv.Font.Size:=svsz;
          Yecr:=svy;
        end;
      '#':begin
          if Sprm='' then begin //retrouver police prc.
            Sprm:=GetS(savpol);
            if Sprm<>'' then SetPol(Sprm); //police
          end else begin
            savpol:=IntToStr(Cv.Font.Size)+Cv.Font.Name+k_TAB+savpol;
            SetPol(Sprm); //police
          end;
        end;
      end;
    until data='';
  end;
var  wg: integer;
begin
//  Raff.Left:=Raff.Left+1;Raff.Right:=Raff.Right-1;Raff.Top:=Raff.Top+1;Raff.Bottom:=Raff.Bottom-1;
  wg:=0;
  savpol:='';
  Recr:=Raff;
  if GCD<>'G' then begin
    w:=0;
    wr_txt(true);//calc lrg
    w:=(Raff.Right-Raff.Left-w) div 2;
    case GCD of
    'G':wg:=0;
    'C':wg:=w;
    'D':wg:=w*2;
    end;
  end;
  Cv.FillRect(Raff);
  w:=Raff.Left+wg;
  wr_txt(false); //crit
end;

procedure Text2RichEdit(RE:TRichEdit;data:string;add:boolean=false);
//idem Text2Canvas
var
  PM,PF,S,Sf,Sprm: string;
  TA: TTextAttributes;
begin
  if not add then RE.Clear;
  repeat
    S:=StrLireEtOterStr0(data,'&&');
    RE.SelText:=S;
    S:=LireEtOterDebutStr(data,1)+' ';
    Sprm:=StrLireEtOterStr0(data,'&');
    case S[1] of
    '@':begin //style
          TA:=RE.SelAttributes;
          while Sprm<>'' do begin
            case Sprm[1] of
            'C':begin
              case (Sprm+' ')[2] of
              'N':TA.Color:=clBlack;
              'B':TA.Color:=clBlue;
              'V':TA.Color:=clGreen;
              'R':TA.Color:=clRed;
              'J':TA.Color:=clYellow;
              end;
              Delete(Sprm,1,1);
            end;
            'G':TA.Style:=TA.Style+[fsBold];
            'g':TA.Style:=TA.Style-[fsBold];
            'I':TA.Style:=TA.Style+[fsItalic];
            'i':TA.Style:=TA.Style-[fsItalic];
            'S':TA.Style:=TA.Style+[fsUnderline];
            's':TA.Style:=TA.Style-[fsUnderline];
            end;
            Delete(Sprm,1,1);
          end;
//                RE.SelAttributes:=TA;
        end;
    '\':begin //txt grec
        Sf:=RE.SelAttributes.Name;
        RE.SelAttributes.Name:='GreekC';
        RE.SelText:=Sprm;
        RE.SelAttributes.Name:=Sf;
      end;
    '#':RE.SelAttributes.Name:=Sprm; //police
    end;
  until data='';
end;

procedure ShowOnTop(F:TForm);  //voir aussi Utils.NormalizeTopJP;
begin
  SetWindowPos(F.Handle,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE {or SWP_SHOWWINDOW});
  F.Show;
end;

procedure ReinitTimer(T:TTimer);
//redmarre le timer  sa valeur d'origine
begin
  T.Enabled:=false;
  T.Enabled:=true;
end;

function PointInRect(P:TPoint;R:TRect):boolean;
begin
  result:=(P.X>=R.Left) and (P.X<=R.Right) and (P.Y>=R.Top) and (P.Y<=R.Bottom);
end;

function PointInControl(P:TPoint;C:TWinControl):boolean;
var
  R: TRect;
begin
  R.TopLeft:=C.ClientToScreen(Point(0,0));
  R.BottomRight:=C.ClientToScreen(Point(C.Width,C.Height));
  result:=PointInRect(P,R);
end;

function MouseInControl(C:TWinControl):boolean;
begin
  result:= PointInControl(Mouse.CursorPos , C);
end;

function SamePoint(P1,P2:TPoint):boolean;
begin
  result:=(P1.X=P2.X) and (P1.Y=P2.Y);
end;

procedure RecenserAideContextuelle;
//recense le contenu des Hints tels que dfinis par l'diteur Delphi
var
i,j: integer;
Txts,NmF: string;
SL: TStringList;
  procedure AddHintCtrl(prfx:string;Ct:TControl);
  var
  S,NmC: string;
  k: integer;
  begin
    S:=Trim(Ct.Hint);
    if S<>'' then begin
      S:=Trim( StringReplace(S,k_CRLF,'$$',[rfReplaceAll]) );
      NmC:=prfx+UpperCase(Ct.Name);
      SL.Add(NmC+k_TAB+S+k_TAB+NmF+'_'+NmC);
    end;
    if (Ct is TFrame) then begin
      for k:= 0 to Ct.ComponentCount-1 do if Ct.Components[k] is TControl then AddHintCtrl(NmC+'.',TControl(Ct.Components[k]));
    end;
  end;
begin
  Txts:='';
  SL:=TStringList.Create;
  SL.Sorted:=true;
  for i := 0 to Application.ComponentCount-1 do begin
    if Application.Components[i] is TForm
    then with TForm(Application.Components[i]) do begin
      NmF:=UpperCase(Name);
      Txts:=Txts+NmF+k_TAB+k_TAB+k_TAB+NmF+k_CRLF;
      SL.Clear;
      for j:= 0 to ComponentCount-1 do if Components[j] is TControl then AddHintCtrl('',TControl(Components[j]));
      for j:=1 to SL.Count do Txts:=Txts+k_TAB+SL[j-1]+k_CRLF;
    end;
  end;
  SL.Free;
  Clipboard.AsText:=Txts;
  ShowMessage('le pp contient le recensement des Hints');
end;

procedure InsererAideContextuelle(PF: string);
//place dans les composants le texte de hint figurant en regard du nom dans le fichier texte PF
//produit un rapport d'erreur rang dans le presse-papiers avant d'afficher un message d'info, ceci seulement si en mode debug
var
TxtsAide,Fenetres,errs: string;
S,S1,S2,NomF,TxAideF: string;
i,j,d,f,lnf: integer;
  procedure AddHintCtrl(prfx:string;Ct:TControl);
  var
  S,NomComp: string;
  d,dt,k: integer;
  begin
    if Ct.Hint='$' then begin
      Ct.Hint:='';
      Ct.ShowHint:=false;
    end else begin
      NomComp:=prfx+UpperCase(Ct.Name);
      d:=Pos(k_TAB+NomComp+k_TAB,TxAideF);
      if d=0 then begin
        errs:=errs+'manque Hint du composant '+NomF+'.'+NomComp+k_CRLF;
      end else begin
        dt:=d+length(NomComp)+2;
        f:=PosEx(k_TAB,TxAideF,dt);
        S:=Copy(TxAideF , dt , f-dt);
        Delete(TxAideF , d , f-d );
        S:=Trim( StringReplace(S,'$$',k_CRLF,[rfReplaceAll]) );
        if S <> '' then begin //sinon on ne change rien
          Ct.ShowHint:=true;
          Ct.Hint:=S;
        end;
        if (Ct is TFrame) then begin
          for k:= 0 to Ct.ComponentCount-1 do if Ct.Components[k] is TControl then AddHintCtrl(NomComp+'.',TControl(Ct.Components[k]));
        end;
      end;
    end;
  end;
begin
  S:=StringFromFile(PF);
//S est sous forme :
//nom_fen tab tab crlf
//tab nom_comp tab <texte (crlf remplacs par $$)> crlf
//  ...
//tab nom_comp tab <texte (crlf remplacs par $$)> crlf
//les commentaires sont admis si ; en 1re colonne
//format  la lecture sous : CRLF nom_fen tab nom_comp tab <texte (crlf remplacs par $$)> ...   (1 ligne par fiche)
//
//un composant dont le Hint est "$" sera marqu ShowHint=false, et ne produira pas d'avertissement
  TxtsAide:=''; Fenetres:='';
  while S<>'' do begin
    S1:=LgetS(S);
    if (Trim(S1)='') or (Copy(S1,1,1)=';') then Continue; //saute lignes blanches et comm
    S2:=Trim( getS(S1) );//nom fen?
    if S2='' then TxtsAide:=TxtsAide+k_TAB+UpperCase(Trim(getS(S1)))+k_TAB+Trim(S1) //composant
             else begin //fiche
               S2:=UpperCase(S2);
               TxtsAide:=TxtsAide+k_CRLF+S2;
               Fenetres:=Fenetres+'*'+S2+'*';
             end;
  end;
  TxtsAide:=TxtsAide+k_CRLF; //fin par CRLF
  errs:='';
  for i := 0 to Application.ComponentCount-1 do begin
    if Application.Components[i] is TForm
    then with TForm(Application.Components[i]) do begin
      ShowHint:=true;                          //if assigned(OnHelp) then showmessage(name);
      NomF:=UpperCase(Name);
      S2:='*'+NomF+'*';
      j:=Pos(S2,Fenetres);
      if j>0 then delete(Fenetres,j,length(S2)); //supprime de la liste des fentres recenses
      d:=Pos(k_CRLF+NomF+k_TAB,TxtsAide);
      if d=0 then begin
        errs:=errs+'manque fiche '+NomF+k_CRLF;
        Continue; //fiche svt
      end;
      lnf:=length(NomF)+2; //cr+lf+nom
      d:=d+lnf;
      f:=PosEx(k_CRLF,TxtsAide,d); //cherche fin de fiche
      TxAideF:=Copy(TxtsAide,d,f-d)+k_TAB;
//      Delete(TxtsAide,d,f-d-1);
//      Delete(TxAideF,1,lnf);//crlf+nom : TxAideF contient la liste : tab nom_comp tab <texte (crlf remplacs par $$)> ...
      for j:= 0 to ComponentCount-1 do if Components[j] is TControl then AddHintCtrl('',TControl(Components[j]));
      if Trim(TxAideF)<>'' then errs:=errs+'inutilis pour '+NomF+' : '+TxAideF+k_CRLF;
    end;
  end;  //clipboard.AsText:=S;
  errs:=Trim( errs+k_CRLF+Fenetres );
  if ModeDebug and (errs<>'') then begin
    Clipboard.AsText:=errs;
    ShowMessage('le pp contient les erreurs au chargt aide ctx');
  end;
end;



end.







































function PathF2DirF(P:string):string;
begin
  P:=ExpandFileName(P);
  P:=ExtractFilePath(P);
  Result:=ExpandFileName(P+'.');
end;

function DirF2DirD(D:string):string;
{doit tre appel  la suite du prcdent}
begin
  if length(D)>3 then repeat
    dec(D[0]);
  until D[length(D)]='\';
  Result:=D;
end;


